<?php
class domrobot {
	private $debug=false;
	private $address;
	private $params;
	private $username;
	private $password;
	private $module_ver = "";

	private $customer=false;
	private $_cookie = "";

	function __construct($address,$username,$password,$language) {
		include_once 'ver.php';
		$this->module_ver = $module_ver;
		$this->address = (substr($address,-1)!='/')?$address."/":$address;
		$this->username = $username;
		$this->password= $password;
		$this->params['lang'] = $language;
	
		if (isset($_SESSION['inwxapicookie'])) {
			$this->_cookie = $_SESSION['inwxapicookie'];
		}
	}
	
	protected function setDebug($debug=false) {
		$this->debug = $debug;
	}
	
	protected function login() {
		$this->params['user'] = $this->username;
		$this->params['pass'] = $this->password; 
		return $this->_call('account','login');
	}
	
	private function _call($object, $method, $params=array()) {
		$callPara = (is_array($params))?array_merge($this->params,$params):$this->params;
		$request = xmlrpc_encode_request(strtolower($object.".".$method), $callPara,array("encoding"=>"UTF-8","escaping"=>"markup","verbosity"=>"no_white_space"));

		$header[] = "Content-Type: text/xml";   
		$header[] = "Connection: keep-alive";
		$header[] = "Keep-Alive: 300";
		$header[] = "X-FORWARDED-FOR: ".@$_SERVER['HTTP_X_FORWARDED_FOR'];
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,$this->address);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); 
		curl_setopt($ch,CURLOPT_TIMEOUT,115);
        curl_setopt($ch,CURLOPT_MAXREDIRS,2);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		curl_setopt($ch,CURLOPT_FOLLOWLOCATION,true);
		curl_setopt($ch,CURLOPT_HEADERFUNCTION,array($this, 'read_header'));
		curl_setopt($ch,CURLOPT_HTTPHEADER,$header);
		curl_setopt($ch,CURLOPT_COOKIE,$this->_cookie);		
		curl_setopt($ch,CURLOPT_POST,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,$request);
		curl_setopt($ch,CURLOPT_USERAGENT,"AWBS/{$this->module_ver} (PHP ".phpversion().")");
		
		$_SiteResponse = curl_exec($ch);
		curl_close($ch); 

		return $response = xmlrpc_decode($_SiteResponse,"UTF-8");
	}

	public function call($object, $method, $params=array()) {
		if (!isset($_SESSION['inwxloggedin']) || $_SESSION['inwxloggedin']!==1 || empty($this->_cookie)) {
			$loginRet = $this->login();
			if (!isset($loginRet['code']) || ($loginRet['code']!=1000 && $loginRet['code']!=1001)) {
				return $loginRet;
			} else {
				$_SESSION['inwxloggedin'] = 1;
			}
		}
		$user_bkp = $this->params['user'];
		$pass_bkp = $this->params['pass'];
		unset($this->params['user'],$this->params['pass']);
		$retCall = $this->_call($object,$method,$params);
		if ($retCall['code']==2002) {
			$this->params['user'] = $user_bkp;
			$this->params['pass'] = $pass_bkp;
			$this->login();
			unset($this->params['user'],$this->params['pass']);
			$retCall = $this->_call($object,$method,$params);
		} 
		return $retCall;
	}

	private function read_header($ch,$string) {
		if (preg_match('/^Set-Cookie:/i', $string)) {
			$cookiestr = trim(substr($string, 11, -1));
			$cookie = explode(';', $cookiestr);
			$cookie = explode('=', $cookie[0]);
			$cookiename = trim(array_shift($cookie)); 
      		$cookiearr[$cookiename] = trim(implode('=', $cookie));

      		foreach ($cookiearr as $key=>$value) {
				$cookie = "$key=$value";
			}
			$_SESSION['inwxapicookie'] = $this->_cookie = $cookie;
		}
		return strlen($string);
	}
}
?>